!$Header$
!$Copyright$
!
      subroutine edit (majc, minc, pltc, labl, pend)
!
!  Subroutine edit is the driver for major and minor editing.
!
!  edit is called by subroutines tran, finish and editre.
!
!     majc     = major edit flag                             (input)
!     minc     = minor edit flag                             (input)
!     pltc     = data tape write flag                        (input)
!     labl     = data tape label write flag                  (input)
!     pend     = end of run flag                             (input)
!
      use kind_specs
      use problem_dimensions
      use time_steps
      use time_data
      use volumes
      use junctions
      use channels
      use arrcom
      use fibwr_data
      use edit_headers
      use restart
      use auxiliary_file
      use minor_edits
      use minor_edit_search
      use minor_edit_summary
      use units
!
      implicit none      
!
!  Dummy arguments
!
      logical(lkd) :: labl, majc, minc, pend, pltc
!      
      intent (in) majc, minc, pend, pltc
!
!  Local variables
!
      logical(lkd) :: chanj, chnby, exists, lfill
      character(5) :: chkpth
      character(kind=ckd,len=32), save :: version
      real(rkd) ::   degk, rvalue, tnow, tstart
      integer(ikd) ::   i, icfl, ich, idx, idxch, ii, ilv, ioff, isi, ismlr, it, j, l, maxx,   &
                     minn, nbin, nchanel, nedv, nfor, npgs, nstart, nthlev, num, numts, meunits, dummy, &
                     status
      integer(ikd), intrinsic :: iabs  
      character(5), dimension(8) :: jtype
      integer(ikd), dimension(2) :: iwt  
      character(5), dimension(4) :: typ
!
      data nbin, nfor/ 60, 60 /
      data typ   /'     ', ' MDY ', ' XHN ', ' HEM '/
      data jtype /'  AFI', '  CHX', '  CHI', '  BLK', '  LLK', '  WTI', '  WTO', '     '/
!
      call timseg (4)
!
!  Do initialization on first call
!      
      if ( val_num<0 ) then
!      
         call time8 ()
!
         nstart = nttsp(1)
         tstart = timex(1)
!
!     Check to see about rewinding the output file
!
!        w-1 (000040) is as a flag for rewinding output file:
!             = -3  rewind inp deck, input edits and steady-state edit
!                   after steady-state edits are written in jvedit
!
         ismlr  = -3
!      
         call smallr (ismlr)
!
!     Set up fortran unit 60 minor edit output - auxiliary file
!
         if ( allocated (ufmt) ) then
            if ( siunit ) then
               isi    = 1
            else
               isi    = 0
            end if
!
            version = version_header(1:32)            
            nedv    = abs (nedi(1)) + 1
!
!        auxiliary file will be a binary file
!
            if ( ufmt(1)=='BINARY  ' ) then
!            
               open (unit=nbin,file='TAPE60',access='SEQUENTIAL',form='UNFORMATTED',status='UNKNOWN',err=100)
!               
               if ( i60hdr==1 ) then
                  write (nbin) problem_title
                  write (nbin) run_date, waltim, version, isi, nedv
                  write (nbin) (var_list(i)%me_flg_reg,     i=2,num_var)
                  write (nbin) (var_list(i)%blk_title,      i=2,num_var)
                  write (nbin) (var_list(i)%var_desc(1:08), i=2,num_var)
                  write (nbin) (var_list(i)%var_desc(9:12), i=2,num_var)                                    
                  write (nbin) (var_list(i)%units,          i=2,num_var)
               end if
!
!        auxiliary file will be an ascii file
!
            else
!            
               open (unit=nfor,file='TAPE60',access='SEQUENTIAL',form='FORMATTED',status='UNKNOWN',err=100)
!               
               if ( i60hdr==1 ) then
                  write (nfor,9240) problem_title
                  write (nfor,9230) run_date, waltim, version, isi, nedv
                  write (nfor,9220) (var_list(i)%me_flg_reg,     i=2,num_var)
                  write (nfor,9220) (var_list(i)%blk_title,      i=2,num_var)
                  write (nfor,9220) (var_list(i)%var_desc(1:8),  i=2,num_var)
                  write (nfor,9220) (var_list(i)%var_desc(9:12), i=2,num_var)                  
                  write (nfor,9220) (var_list(i)%units,          i=2,num_var)
               end if
            end if
         end if  
!
!     Allocate memory for minor edit summary variables
!      
         nedv    = abs (nedi(1)) + 1
!         
         call allok8_me_sum (nedv)
!
!     Open scratch file to store selected minor edits for printer plots
!
         if ( nedi(1)<=0 ) then
            inquire (20,opened=exists)
            if ( .not.(exists) ) then
               prnplt_rec = 0
               open (20,file='TAPE20',status='UNKNOWN',access='SEQUENTIAL',form='UNFORMATTED',err=200)
            end if
         end if
!
         val_num = 0         
!      
      end if
!      
!      nthlev  = npnbot(1) + nplane(1) + npntop(1)
!      
      lfill  = .false.
      chanj  = .true.
      chnby  = .true.
!
!  Get average time-step size since last minor edit
!
      tnow   = timex(1)
      numts  = nttsp(1) - nstart
!      
      if ( numts>0 ) then
         dtavg(1) = (tnow - tstart)/numts
      else
         dtavg(1)  = 0.0d0
      end if
      tstart = tnow
      nstart = nttsp(1)
!
!  --------------------------------------------------------------
!  Write to restart file and/or trailer label 
!
      if ( ( ldmp(1)/=0 .or. ldmp(1)/=-2 ) .and. ( pltc .or. labl )) then
         if ( .not.(nttsp(1)<=0 .and. nogo(1) )) then
!         
            if ( record_number<=0 ) then
!            
               call write_restart_header
!
            end if
!
            call write_restart_record
!
            if ( labl ) then
               call write_restart_trailer
            end if                                       
!            
         end if
      end if
!
!  --------------------------------------------------------------
!  Major edit
!
   if (majc ) then  
!
!  Write system values
!
      call subpg (dummy)
!      
      write (6,9010)
      if ( siunit ) then
         write (6,9020) nstep(1), pnorm(1), power(1), ptherm(1)*conv(12), eb(1)*conv(10), bmassw(1)*conv(8),  &
                        bmassa(1)*conv(8), dtavg(1), dtolds(1), timex(1), nttsp(1)
      else
         write (6,9030) nstep(1), pnorm(1), power(1), ptherm(1), eb(1), bmassw(1),  &
                        bmassa(1), dtavg(1), dtolds(1), timex(1), nttsp(1)
      end if
!
!  Write volume values
!
      if ( ncflow(1)>0 ) then
         write (6,9050)
      else
         write (6,9040)
      end if
!      
      if ( siunit ) then
         write (6,9060)
      else
         write (6,9070)
      end if
!
!  If channel model & no aux edit - edit non-channel volumes only
!
      do i = 1, nvol(1)
         if ( num_chan>0 .and. .not.auxedt .and. olvoln(i)>=1000 ) exit
!        
         if ( iprzr(1)>0 .and. ineq(i)>0 ) then
!        
!        non-equilibrium pressurizer volume -- special edit
!        
            call edit_pressurizer (i)
!
            cycle
         end if
!         
         if ( siunit ) then
!           
            degk   = cftok (temp(i))  !   temperature conversion to Kelvin
!        
            if ( ncflow(1)>0 ) then
               write (6,9080) olvoln(i), p(i)*conv(4), fmass(i)*conv(8), hw(i)*conv(7), aved(i)*conv(9), degk, avex(i), &
                              voidv(i), qspl(i)*conv(13), xnc(i)                                                                                    
            else
               write (6,9080) olvoln(i), p(i)*conv(4), fmass(i)*conv(8), hw(i)*conv(7), aved(i)*conv(9), degk, avex(i), &
                              voidv(i), qspl(i)*conv(13)
            end if
!        
         else if ( ncflow(1)>0 ) then
            write (6,9080) olvoln(i), p(i), fmass(i), hw(i), aved(i), temp(i), avex(i), voidv(i), qspl(i), xnc(i) 
         else
            write (6,9080) olvoln(i), p(i), fmass(i), hw(i), aved(i), temp(i), avex(i), voidv(i), qspl(i)
         end if
!         
      end do         
!
!  Write junction values
!
      write (6,9090)
!
      if ( siunit ) then
         write (6,9100)
      else
         write (6,9110)
      end if
!
      do i = 1, njun(1)
!
!  Set fibwr edit path identifiers for non-channel model fibwr junctions 
!
         ich    = oljunn(i)/1000
!         
         if ( ich==0 ) then
            if ( ifbrch(i)>0 ) then
               idxch  = ifbrch(i)
!
               if ( idxchi(idxch)==i ) then
                  chkpth = jtype(3)        ! channel inlet junction
               else if ( idxcho(idxch)==i ) then
                  chkpth = jtype(2)        ! channel outlet junction
               else if ( idxwri(idxch)==i ) then
                  chkpth = jtype(6)        ! water rod inlet juncion for channel
               else if ( idxwro(idxch)==i ) then
                  chkpth = jtype(7)       ! water rod outlet juncion for channel
               else if ( idxafi(idxch)==i ) then
                  chkpth = jtype(1)        ! active channel inlet junction
               else
                  chkpth = typ(itp(i))     ! choking mode 
               end if
!
               do l = 1, 9
                  if ( idxll(l,idxch)==i ) then
                     chkpth = jtype(5)     ! lateral leakage junction
                     exit
                  end if
               end do
!
!  set FIBWR edit path identifier for non-channel model bypass junctions
!
            else if ( allocated(i_fibwr)) then
                 if ( npath>0 .and. idxbpj(1)==i ) then
                    chkpth = jtype(4)           ! bypass inlet junction
                 else  
                    chkpth = typ(itp(i))
                 end if
!
!  normal junction - set choking mode flag
!
            else
               chkpth = typ(itp(i))        ! choking mode 
            end if
!
            if ( .not.lfill .and. iw(i,1)==0  ) then
!               write (6,9140)    !  write fill junction header
               lfill  = .true.
            end if
!            
            if ( siunit ) then
               write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i)*conv(11), hp(i)*conv(7), spvj(i)*conv(6),  &
                              delp(i)*conv(4),dele(i)*conv(4), delf(i)*conv(4), dela(i)*conv(4), pumpp(i)*conv(4)
            else
               write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i), hp(i), spvj(i),  &
                              delp(i), dele(i), delf(i), dela(i), pumpp(i)
            end if
!
!     Do channel edit for junction quantities 
!
         else       
!      
            idxch  = ifbrch(i)
            ilv    = oljunn(i)/10 - ich*100
            icfl   = oljunn(i) - (oljunn(i)/10)*10
            chkpth = jtype(8)
            it     = 8
!
!        channel inlet junction - ci
!
            if ( ilv==1 .and. icfl==0 .and. idxch<=0 ) then
               it     = 3
               chkpth = jtype(3)
!
!        inlet junction to active core region - in (skip edit if not running fibwr model)
!
            else if ( ilv==(npnbot(1)+1) .and. npath>0 .and. ich<=nchann(1) ) then
               chkpth = jtype(1)
!
!        core outlet junction - ex
!
            else if ( ilv==(nthlev+1) ) then
               it     = 2
               chkpth = jtype(2)
!
!        skip edits for junctions that get here
!
            else
               cycle
            end if
!
            if ( num_chan>0 .and. .not.auxedt .and. chanj ) then
               write (6,9120)    !  write channel junction header
               chanj = .false.
            end if
!
            if ( ich>nchanel .and. chnby ) then
               write (6,9130)    !  write bypass junction header
               chnby = .false.
            end if
!            
            if ( siunit ) then
               write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i)*conv(11), hp(i)*conv(7), spvj(i)*conv(6),  &
                                 delp(i)*conv(4),dele(i)*conv(4), delf(i)*conv(4), dela(i)*conv(4), pumpp(i)*conv(4)
            else
               write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i), hp(i), spvj(i),  &
                                delp(i), dele(i), delf(i), dela(i)
            end if
!
!        Edit active channel leakage paths and water rod junctions if fibwr model used and last edit was for the channel inlet
!
            if ( idxch>0 .and. it==3 .and. ich<=nchanel ) then
!
!        lateral leakage junction or cross-flow junction - lk
!
               chkpth = jtype(5)
!
               do l = 1, 9
                  if ( idxll(idxch,l)<=0 ) exit
!
                  if ( siunit ) then
                     write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i)*conv(11), hp(i)*conv(7), spvj(i)*conv(6),  &
                                       delp(i)*conv(4),dele(i)*conv(4), delf(i)*conv(4), dela(i)*conv(4)
                  else
                     write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i), hp(i), spvj(i),  &
                                       delp(i), dele(i), delf(i), dela(i)
                  end if
               end do
!
!           water tube junction - wt
!
               if ( idxwri(idxch)>0 ) then
                  iwt(1) = idxwri(idxch)
                  iwt(2) = idxwro(idxch)
                  do l = 1, 2
                     chkpth = jtype(5+l)
!
                     if ( siunit ) then
                        write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i)*conv(11), hp(i)*conv(7), spvj(i)*conv(6),  &
                                          delp(i)*conv(4),dele(i)*conv(4), delf(i)*conv(4), dela(i)*conv(4)
                     else
                        write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i), hp(i), spvj(i),  &
                                          delp(i), dele(i), delf(i), dela(i)
                     end if
                  end do
               end if
!
!        Edit bypass channel leakage paths if fibwr model used and last edit was for the channel inlet
!
            else if ( idxch>0 .and. it==3 .and. ich>nchanel ) then
!
!           FIBWR bypass leakage junction 
!
               chkpth = jtype(4)
!
               do l = 1, 9
                  if ( idxli(idxch,l)<=0 ) exit
!
                  if ( siunit ) then
                     write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i)*conv(11), hp(i)*conv(7), spvj(i)*conv(6),  &
                                       delp(i)*conv(4),dele(i)*conv(4), delf(i)*conv(4), dela(i)*conv(4)
                  else
                     write (6,9150) oljunn(i), iw(i,1), iw(i,2), chkpth, wp(i), hp(i), spvj(i),  &
                                       delp(i), dele(i), delf(i), dela(i)
                  end if
               end do
!               
            end if
!
         end if
      end do
!
!  Edit five-equation model volume parameters
!
      if ( neweqs(1)>0 ) call edit_five_eq 
!
!  Edit slip quantities
!
      if ( isflag(1)/=0 ) call edit_slip

!
!  Edit bubble rise parameters
!
      if ( nbub(1)>0 ) call edit_bubble_rise
!
!  Edit centrifugal pump quantities
!
      if ( npmpc(1)>0 ) call edit_pumps

!
!  Edit conductor parameters
!
      if ( nslb(1)>0 )then
         if ( .not.irunar .or. auxedt ) then
            call edit_conductors
         else
            if ( nslb(1)/=ncor(1) ) call edit_conductors
         end if
      end if
!
!  Edit core parameters
!
      if ( ncor(1)>0 ) then
         if ( .not.irunar .or. auxedt ) then
            call edit_core
         else
            call edit_channel
         end if
      end if
!
!  Edit auxiliary dnb parameters
!
      if ( idnbc(1)/=0 ) call edit_dnb
!
!  Edit kinetics parameters
!
      if ( nodel(1)==1 ) call edit_pt_kinetics
!
!  Edit space time kinetics parametrs
!
      if ( nodel(1)==2 ) call edit_1d_kinetics
!
!  Edit non-conducting heat exchangers
!
      if ( nhtx(1)>0 ) call edit_htx
!
!  Write restart record number to major edit
!
      if ( rst_out>0 .and. ( ldmp(1)/=0 .or. ldmp(1)/=-2 ).and. minc ) then
         if ( .not.(nttsp(1)<=0 .and. nogo(1) ) .and. ( pltc .or. labl )) then
!            
                        write (6,9200) record_number, rst_out
            if ( labl ) write (6,9210) rst_out
         end if
      end if
!
   end if
!
!  --------------------------------------------------------------
!  Process minor edit related options
!
   nedv    = abs (nedi(1))   
!   
   if ( nedv>0 ) then
!               
!  Do minor edits
!
      if ( minc ) then
!
!     Save minor edit variables for this time step
!
         val_num = val_num + 1
!
         do i = 1, num_var
            idx    = var_list(i) % me_index 
            ioff   = var_list(i) % reg_offset
            rvalue = me_value (idx, ioff)
            var_list(i)%var_value(val_num) = rvalue            
!                                          
            if ( siunit ) then
               meunits = me_list(idx) % me_units
               if ( meunits==1 ) then
                  var_list(i) % var_value(val_num) = cftok (rvalue)  !  temperature conversion to Kelvin
               else
                  var_list(i) % var_value(val_num) = rvalue * conv(meunits)
               end if
            end if
         end do
!
!     Write minor edit variables to fortran unit 60 if requested
!
         if ( num_ufmt>0 ) then
!
!        binary data tape option
!
            if ( ufmt(1)=='BINARY  ' ) then
               write (nbin) (var_list(i) % var_value(val_num), i=2, num_var)
!
!        formated data tape option
!
            else
               write (nfor,ufmt(1:num_ufmt)) (var_list(i) % var_value(val_num), i=2, num_var)
            end if
         end if
!
!     Save minor edit data if printer plots are requested
!
         if ( nedi(1)<0 ) then
            write (20) (var_list(i) % var_value(val_num), i=1,num_var)
            prnplt_rec = prnplt_rec + 1
         end if
!         
!     Test if minor edits need to be printed
!
         if ( pend .or. val_num>=50 .or. nogo(1) ) then
!
!        print minor headings
!
            num    = abs(nedi(1))
            npgs   = (num + 7)/8
            num    = nedv
            minn   = 2
            maxx   = 1
!
            do i = 1, npgs
!
!           write page heading of minor edits
!            
               call subpg(dummy)
!               
               write (6,9160)
               maxx   = maxx + min (num, 8)
               write (6,9170) var_list(1) % blk_title, (var_list(j) % blk_title, j=minn, maxx)               
               write (6,9180) var_list(1) % var_desc,  (var_list(j) % var_desc,  j=minn, maxx)
               write (6,9170) var_list(1) % units,     (var_list(j) % units,     j=minn, maxx)
!
!           write time values
!
               do l = 1, val_num
                  write (6,9190) var_list(1) % var_value(l), (var_list(j) % var_value(l), j=minn, maxx)
               end do
               num    = num  - 8
               minn   = maxx + 1
            end do
            val_num = 0            
         end if
!         
      end if
!
   end if
!      
      call timseg(-4)
!
      return
!         
  100 continue
      call remark(' ERROR ON OPEN IN EDIT: FILE = TAPE60 ')
      call fabend
!      
  200 continue
      call remark(' ERROR ON OPEN IN EDIT: FILE = TAPE20 ')
      call fabend
!
 9010 format (/'   NORMALIZED    CORE         THERMAL      ENERGY       TOTAL MASS   NCG MASS     AVERAGE      CURRENT      ',  &
               'ELAPSED    TIME STEP NUM'/'   CORE          POWER        POWER        BALANCE    ',                             &
               '  BALANCE      BALANCE      TIME STEP    TIME STEP    TIME       STANDRD/ACTUL')
 9020 format ( '   POWER         (MW)         (WATTS)      (KJ)         (KG)         (KG)         (SEC)        (SEC)        ',  &
               '(SEC)      ',i11/1x,1p,e13.5,1x,8E13.5,i11)
 9030 format ( '   POWER         (MW)         (BTU/HR)     (BTU)        (LBM)        (LBM)        (SEC)        (SEC)        ',  &
               '(SEC)      ',i11/1x,1p,e13.5,1x,8E13.5,i11)
 9040 format (/' VOLUME          AVG. PRES.   TOT. MASS    AVG. ENTH.   AVG. DEN.    AVG. TEMP.   AVG. QUAL.   VOID FRAC.   ',  &
               'POWR TO H2O')
 9050 format (/' VOLUME          AVG. PRES.   TOT. MASS    AVG. ENTH.   AVG. DEN.    AVG. TEMP.   AVG. QUAL.   VOID FRAC.   ',  &
               'POWR TO H2O  NCG QUALITY')
 9060 format ( ' NUMBER          (KPA)        (KG)         (KJ/KG)    ',                                                        &
               '  (KG/M3)      (DEG. K)                               (KW)   ')
 9070 format ( ' NUMBER          (PSIA)       (LB)         (BTU/LB)   ',                                                        &
               '  (LB/FT3)     (DEG. F)                               (BTU/SEC)')
 9080 format (i7,8x,1p,9E13.5)
 9090 format (/' JUNCTION   CONNECTS    CHOK/ JUN. FLOW    JUN. ENTH. ',                                                        &
               '  JUN. SPVL.   P  R  E  S  S  U  R  E    D  I  F  F  E  R  E  N  T  I  A  L  S')
 9100 format ( ' NUMBER     VOLUMES     PATH  (KG/SEC)     (KJ/KG)    ',                                                        &
               '  (M3/KG)      VEL. KPA     ELEV. KPA    FRIC. KPA    ACCL. KPA    PUMP KPA')
 9110 format ( ' NUMBER     VOLUMES     PATH  (LB/SEC)     (BTU/LB)   ',                                                        &
               '  (FT3/LB)     VEL. PSI     ELEV. PSI    FRIC. PSI    ACCL. PSI    PUMP PSI')
 9120 format ( ' CHANNEL JUNCTIONS')
 9130 format ( ' BYPASS JUNCTIONS')
 9140 format ( ' FILL JUNCTIONS')
 9150 format (2I7,' TO',i7,a5,1p,e12.5,7E13.5)
 9160 format (//)
 9170 format (5x,a8,8(6x,a8))
 9180 format (3x,a12,8(2x,a12))
 9190 format (9(1x,1pe13.5))
 9200 format (//'  DATA RECORD NUMBER',i6,' WAS WRITTEN TO UNIT',i3)
 9210 format ( /'  TRAILER LABEL WRITTEN ON UNIT',i3)
 9220 format (15A8)
 9230 format (2(A8),A32,2(I8))
 9240 format (A80)
      end subroutine edit
