!$Header$
!$Copyright$
!===============================================================================================
!  Module arrcom is used to pass information between 3D kinetics and thermal-hydraulics routines                               
!===============================================================================================
!
      module arrcom 
! 
      use kind_specs 
! 
      integer(kind=ikd) , parameter ::  &
         lenrdt = 75        !  dimension of rdata array
!      
      real(kind=ikd),  dimension(lenrdt) , parameter  ::  &
          rdata = 0.0d0     !  vector used to pass data between 3D kinetics and thermal hydraulics
      real(kind=rkd), save  ::  &
          dtarr = 0.0d0     !  current shared timestep                                    
 ! 
      integer(kind=ikd), save  ::  &
          iabwr = 0, &      !  plant mode flag  - 0 = pwr , 1 = bwr
         iadjnt = 0, &      !  adjoint calculation flag - 0 = no, 1 = yes
         idpowb = 0, &      !  ftb file id to power file                                 
         idthbl = 0, &      !  ftb file id to th file 
         idxbor = 0, &      !  ftb index to indexs for boron concentrations - < 0 use cout, > 0 use convol 
         idxcrt = 0, &      !  ftb index of cout's for control rod groups                 
          imshz = 0, &      !  index to z 
           ipud = 0, &      !  ipud = flag for purdue numerics -  1 = yes, 0 = no (default)                                      
           irdt = 0, &      !  offset into rdata array -----<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<remove mpp
         ixpden = 0, &      !  ftb index of channel power density file                    
           ixth = 0, &      !  index to x 
           iyth = 0, &      !  index to y 
           izth = 0, &      !  index to z
          jvip1 = 0, &      !  ftb file index to row limits                              
         l5or67 = 0, &      !  unit for inpsim input (5 or 67)                           
          mcola = 0, &      !  number of columns (th mesh)
         mcount = 0, &      !  counter for tape41 edits
          mplna = 0, &      !  number of planes  (th mesh)                               
           ntcn = 0, &      !  interation counter                                         
          mrowa = 0, &      !  number of rows    (th mesh)                               
         ncount = 0, &      !  counter for tape42 edits
          nyta1 = 0, &      !  first powered row                                         
          nyta2 = 0, &      !  last powered row                                          
          nzta1 = 0, &      !  first powered plane                                       
          nzta2 = 0         !  last powered plane                                        
!          
      integer(kind=ikd), parameter :: mxaxis = 50  
!      
      integer(kind=ikd), dimension(mxaxis, 3, 2) :: & 
          index = 0         !  ???
! 
      logical(kind=lkd), save  ::  &
         auxedt = .false., &      !  when true, select "channel edit" for output                  
         endret = .false., &      !  when true, retran end, terminate job                         
         irunar = .false., &      !  when true, run 3-D kinetics
         minedt = .false., &      !  when true, write tape41 and tape42 edits
         nogoar = .false., &      !  when true, retran error, abort job                           
         retedt = .false., &      !  when true, write retran edits                                      
         stcnvg = .false.         !  when true, steady-state iterations converged                 
!
!  variable to define reflector properties (if frozen by nfreez lt 0)
!
      real(kind=rkd), parameter  ::  &
         rftf = 0.0d0, &    !
         rftm = 0.0d0, &    !
         rfxx = 0.0d0       !     
! 
      integer(kind=ikd), parameter  ::  &
           lrfp = 0         ! 
!           
      end module arrcom 
