!$Header$
!$Copyright$
!
      module s_i2_pntr
      interface
         subroutine i2_pntr (allocatd, nsiz, msiz, len, i2pntr, i2targt)
!
!  Subroutine to determine space requirements and assign array pointers for integer 2D arrays.
!
!     allocatd = locical used to assign pointer values                                             input
!              = .false. - calculate space required
!              = .true.  - make pointer association
!     nsiz     = size of pointer array 1st dimension                                               input
!     msiz     = size of pointer array 2nd dimension                                               input
!     len      = cummulative length of target array                                                input/output
!     i2pntr   = pointer to associate with target                                                  input/output
!     i2targt  = target  array                                                                     input
!
            use kind_specs
!
            integer(kind=ikd) len, msiz, nsiz
            logical(kind=lkd) allocatd
            integer(kind=ikd),   pointer :: i2pntr(:,:)
            integer(kind=ikd),   target  :: i2targt(:,:)
            intent (in) allocatd, nsiz, msiz, i2targt
            intent (inout) len
         end subroutine i2_pntr
      end interface
      end module s_i2_pntr
