!$Header$
!$Copyright$
!
      module s_l2_pntr
      interface
         subroutine l2_pntr (allocatd, nsiz, msiz, len, l2pntr, l2targt)
!
!  Subroutine to determine space requirements and assign array pointers for logical 2D arrays.
!
!     allocatd = locical used to assign pointer values                                             input
!              = .false. - calculate space required
!              = .true.  - make pointer association
!     nsiz     = size of pointer array 1st dimension                                               input
!     msiz     = size of pointer array 2nd dimension                                               input
!     len      = cummulative length of target array                                                input/output
!     l2pntr   = pointer to associate with target                                                  input/output
!     l2targt  = target  array                                                                     input
!
            use kind_specs
!
            integer(kind=ikd) len, msiz, nsiz
            logical(kind=lkd) allocatd
            logical(kind=lkd),   pointer :: l2pntr(:,:)
            logical(kind=lkd),   target  :: l2targt(:,:)
            intent (in) allocatd, nsiz, msiz, l2targt
            intent (inout) len
         end subroutine l2_pntr
      end interface
      end module s_l2_pntr
