!$Header$
!$Copyright$
!
      module s_r2_pntr
!
!  Subroutine to determine space requirements and assign array pointers for 2D real arrays.
!
!     allocatd = locical used to assign pointer values                                             input
!              = .false. - calculate space required
!              = .true.  - make pointer association
!     nsiz     = size of pointer array 1st dimension                                               input
!     msiz     = size of pointer array 2nd dimension                                               input
!     len      = cummulative length of target array                                                input/output
!     r2pntr   = pointer to associate with target                                                  input/output
!     r2targt  = target  array                                                                     input
!      
      interface
         subroutine r2_pntr (allocatd, nsiz, msiz, len, r2pntr, r2targt)

            use kind_specs
!
            integer(kind=ikd) len, msiz, nsiz
            logical(kind=lkd) allocatd
            real(kind=rkd),   pointer :: r2pntr(:,:)
            real(kind=rkd),   target  :: r2targt(:,:)
            intent (in) allocatd, nsiz, msiz, r2targt
            intent (inout) len
         end subroutine r2_pntr
      end interface
      end module s_r2_pntr
